#include <bits/stdc++.h>
using namespace std;

#define int long long

signed main() {
	
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	int n, q, brojac=0, m=0, r=0;
	cin >>n >> q;
	
	int d[n], p[n], j[q];
	
	for(int i=0; i<n; i++) {
		cin >> d[i] >> p[i];
	}
	
	for(int i=0; i<q; i++)
	cin >> j[i];
	
	n=0;
	for(int i=1; i<j[q]; i++){
		
		
		if(i==d[m]){
			n+=p[m];
			m++;
		}
		
		if(n>0){
		brojac++;
		n--;
		}
		
		if(j[r] == i ){
		cout<<brojac<<endl;
		r++;
		
			
	}
		
	}
	
	
	return 0;
}